<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/language.oop5.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'ja',
  ),
  'this' => 
  array (
    0 => 'language.oop5.autoload.php',
    1 => 'クラスのオートローディング',
  ),
  'up' => 
  array (
    0 => 'language.oop5.php',
    1 => 'クラスとオブジェクト',
  ),
  'prev' => 
  array (
    0 => 'language.oop5.constants.php',
    1 => 'クラス定数',
  ),
  'next' => 
  array (
    0 => 'language.oop5.decon.php',
    1 => 'コンストラクタとデストラクタ',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'ja',
    'path' => 'language/oop5/autoload.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.oop5.autoload" class="sect1">
 <h2 class="title">クラスのオートローディング</h2>
 <p class="para">
  オブジェクト指向アプリケーションを作成する開発者の多くは、
  クラス定義毎に一つのPHPソースファイルを作成します。
  最大の問題は、各スクリプトの先頭に、必要な読み込みを行う長いリストを
  記述する必要があることです(各クラスについて一つ)。
 </p>
 <p class="para">
  <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span> 関数を使うと、
  任意の数のオートローダーを登録でき、
  クラスやインターフェイスが定義されていなくても自動的に読み込めるようになります。
  オートローダーを登録すれば、PHPがエラーで止まる前にクラスをロードする最後の
  チャンスが与えられます。
 </p>
 <p class="para">
   クラスに類似した言語構造は、同じやり方でオートロードできます。
   これには、クラス、インターフェイス、トレイト、列挙型が含まれます。
 </p>
 <div class="caution"><strong class="caution">警告</strong>
  <p class="para">
   PHP 8.0.0 より前のバージョンでは、
   <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span> 関数でもクラスやインターフェイスのオートロードが可能でした。
   しかし、この関数は
   <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span> 関数に比べると柔軟性という点で劣っています。
   そのため、<span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span>
   関数は PHP 7.2.0 で推奨されなくなり、
   PHP 8.0.0 で削除されました。
  </p>
 </div>
 <blockquote class="note"><p><strong class="note">注意</strong>: 
   <p class="para">
    複数のオートローダーを複数回登録するために、
    <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span>
    を複数回コールしても構いません。
    但し、オートロードを行う関数から例外がスローされると、
    オートロードのプロセスが中断され、
    後続のオートロード関数の実行ができなくなります。
    よって、オートロード関数から例外をスローすることは、
    全くお勧めできません。
   </p>
 </p></blockquote>
 <p class="para">
  <div class="example" id="example-238">
   <p><strong>例1 オートロードの例</strong></p>
   <div class="example-contents"><p>
    この例は、 クラス <code class="literal">MyClass1</code> および
    <code class="literal">MyClass2</code> をそれぞれ
    <var class="filename">MyClass1.php</var> および
    <var class="filename">MyClass2.php</var> からロードします。
   </p></div>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$class_name</span><span style="color: #007700">) {<br />    include </span><span style="color: #0000BB">$class_name </span><span style="color: #007700">. </span><span style="color: #DD0000">'.php'</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$obj  </span><span style="color: #007700">= new </span><span style="color: #0000BB">MyClass1</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">$obj2 </span><span style="color: #007700">= new </span><span style="color: #0000BB">MyClass2</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

   </div>
   <div class="example" id="example-239">
    <p><strong>例2 オートロードの別の例</strong></p>
    <div class="example-contents"><p>
     この例は、インターフェイス <code class="literal">ITest</code> をロードしようとします。
    </p></div>
    <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /><br />spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$name</span><span style="color: #007700">) {<br />    </span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$name</span><span style="color: #007700">);<br />});<br /><br />class </span><span style="color: #0000BB">Foo </span><span style="color: #007700">implements </span><span style="color: #0000BB">ITest </span><span style="color: #007700">{<br />}<br /><br /></span><span style="color: #FF8000">/*<br />string(5) "ITest"<br /><br />Fatal error: Interface 'ITest' not found in ...<br />*/<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

   </div>
   <div class="example" id="example-240">
    <p><strong>例3 Composerのオートローダーの利用</strong></p>
    <div class="example-contents"><p>
     <a href="https://getcomposer.org/" class="link external">&raquo;&nbsp;Composer</a> は <code class="literal">vendor/autoload.php</code> ファイルを生成します。
     これは Composer によって管理されているパッケージを自動的に読み込むよう設定されています。
     このファイルを読み込むことで、これらのパッケージを追加の作業なしで利用できるようになります。
    </p></div>
    <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /></span><span style="color: #007700">require </span><span style="color: #0000BB">__DIR__ </span><span style="color: #007700">. </span><span style="color: #DD0000">'/vendor/autoload.php'</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">$uuid </span><span style="color: #007700">= new </span><span style="color: #0000BB">Ramsey\Uuid\Uuid</span><span style="color: #007700">::</span><span style="color: #0000BB">uuid7</span><span style="color: #007700">();<br /><br />echo </span><span style="color: #DD0000">"Generated new UUID -&gt; "</span><span style="color: #007700">, </span><span style="color: #0000BB">$uuid</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">toString</span><span style="color: #007700">(), </span><span style="color: #DD0000">"\n"</span><span style="color: #007700">;<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

   </div>
  </p>

  <div class="simplesect">
   <h3 class="title">参考</h3>
   <p class="para">
    <ul class="simplelist">
     <li><span class="function"><a href="function.unserialize.php" class="function">unserialize()</a></span></li>
     <li><a href="var.configuration.php#ini.unserialize-callback-func" class="link">unserialize_callback_func</a></li>
     <li><a href="var.configuration.php#ini.unserialize-max-depth" class="link">unserialize_max_depth</a></li>
     <li><span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span></li>
     <li><span class="function"><a href="function.spl-autoload.php" class="function">spl_autoload()</a></span></li>
     <li><span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span></li>
    </ul>
   </p>
  </div>

 </div><?php manual_footer($setup); ?>